//   IMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM;
//   :                                                                    :
//   : module:      conninfo.c                                            :
//   : abstract:    This module shows how to make 3.x system calls using  :
//   :              the F2 Shell Interface for the Get Connection Info    :
//   :              API, obviously it requires the NetWare Shell.         :
//   :                                                                    :
//   :              This call may need to be made iteratively to return   :
//   :              all of the restriction information.  For simplicity,  :
//   :              this example only makes the call once.                :
//   :                                                                    :
//   : environment: NetWare 3.x v3.11                                     :
//   :              Borland C 3.1                                         :
//   :                                                                    :
//   :  This software is provided as is and carries no warranty           :
//   :  whatsoever.  Novell disclaims and excludes any and all implied    :
//   :  warranties of merchantability, title and fitness for a particular :
//   :  purpose.  Novell does not warrant that the software will satisfy  :
//   :  your requirements or that the software is without defect or error :
//   :  or that operation of the software will be uninterrupted.  You are :
//   :  using the software at your risk.  The software is not a product   :
//   :  of Novell, Inc. or any of subsidiaries.                           :
//   HMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM<
//
//                         ****** N O T I C E ******
//
//     This API call can cause a server abend if a connection number is
//     used that is greater than what the OS supports.
//
//     This software is considered pre-release and may be used at your own
//     risk and has been provided due to the many requests of our cust-
//     omers.  Support for this module will be provided at the sole
//     discretion of Novell, Inc.
//

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>

#include "nwsys.c"

//
//  First of all, we define the request and reply structures which are
//  needed for the Get Connection Information API call.  These structures are
//  laid out according to the System Call documentation.
//

struct  REQUEST {
	WORD    sflen;                 // length of the structure
	BYTE    sfcode;                // the subfunction code
	DWORD   connNumber;            // target connection number
}Request;

struct  {
    DWORD   userID;                // Connection's User ID
    WORD    userType;
    BYTE    userName[48];
    BYTE    loginTime[7];
    BYTE    reserved;
}Reply;

int main()
{
	int retCode;

//
//  Build the request buffer
//
	Request.sflen = (sizeof Request) ;
	Request.sfcode = 0x1c;                  // subfunction code
    printf("Enter connection number: ");
    scanf("%ld", &(Request.connNumber));

	retCode = NWSystemCall(0x17, &Request, sizeof(Request),
                                 &Reply,   sizeof(Reply));

    if (retCode != 0) {
        printf("Get Connection Information call failed.  Retcode = %d\n",
            retCode);
        return(-1);
    }
    printf("User ID: 0x%lx  User Name: %s\n", DWordSwap(Reply.userID),
        Reply.userName);
    return(0);
}
